/* 

                          Firewall Builder

                 Copyright (C) 2001 NetCitadel, LLC

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: InterfaceData.hh,v 1.4 2002/08/29 00:34:49 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/



#ifndef __INTERFACE_DATA_HH_
#define __INTERFACE_DATA_HH_

#include "config.h"

#include <gtk--.h>

#include "fwbuilder/Interface.hh"

struct InterfaceData
{
    std::string id;
    std::string name;
    std::string address;
    std::string netmask;
    int         securityLevel;
    bool        isDyn;
    std::string physicalAddress;
    std::string label;
    std::string networkZone;

    InterfaceData() { isDyn=false; securityLevel=0; }

    InterfaceData(const libfwbuilder::Interface &iface) 
    {
        id=iface.getId();
        name=iface.getName();
        address=iface.getAddress().toString();
        netmask=iface.getNetmask().toString();
        securityLevel=iface.getSecurityLevel();
        isDyn=iface.isDyn();
        physicalAddress=iface.getPhysicalAddress();
        label=iface.getLabel();
        networkZone=iface.getStr("network_zone");
    }

};
#endif
