/* 

                          Firewall Builder

                 Copyright (C) 2000 NetCitadel, LLC

  Author:  Vadim Kurland     vadim@vk.crocodile.org

  $Id: PIXAdvancedFWDialog.hh,v 1.1 2002/11/26 05:24:37 vkurland Exp $


  This program is free software which we release under the GNU General Public
  License. You may redistribute and/or modify this program under the terms
  of that license as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  To get a copy of the GNU General Public License, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/


#ifndef _PIXADVANCEDFWDIALOG_HH
#  include "PIXAdvancedFWDialog_glade.hh"
#  define _PIXADVANCEDFWDIALOG_HH
#include "glademm_support.hh"

#include "FixupWidget.hh"

#include "fwbuilder/Firewall.hh"

class PIXAdvancedFWDialog : public PIXAdvancedFWDialog_glade
{   
    friend class PIXAdvancedFWDialog_glade;

    libfwbuilder::Firewall *fwobj;
    bool ok;
    std::map<std::string,std::string>  log_facilities;
    std::map<std::string,std::string>  log_levels;

    std::list<std::string>             fixup_names;
    std::map<std::string,std::string>  fixup_xml_elements;

    void on_ok_clicked();
    void on_cancel_clicked();
    void on_changed();
    void on_default_timeouts_clicked();
    void on_default_fixups_clicked();

    void on_add_fixup_clicked();
    
    void wrk2dlg();
    void dlg2wrk();

    void setDefaultTimeoutValue(const string &option);
    FixupWidget* createDefaultFixupWidget(const string &name);

    void addFixupWidget(FixupWidget *fw);
    void addFixupWidget(const std::string &n,bool dis,
                        int  p1,int p2,const std::string &on,bool ov );
    void addFixupWidget(const std::string &name,const std::string &s);
    void clearFixupWidgets();
    
    void loadFixups();
    void saveFixups();

    public:

    PIXAdvancedFWDialog(libfwbuilder::Firewall *fobj);

    bool run();
};

#endif
